account/urls.py
from django.urls import path
from . import views
app_name = 'account'
urlpatterns = [
    path('', views.HomeView.as_view(), name='home'),
    path('login-email/', views.LoginWithEmail.as_view(), name='login_email'),
    path('login-phone', views.LoginWithPhone.as_view(), name='login_phone'),
    path('check-sms', views.VerifySMSCode.as_view(), name='verify_code'),
    path("repeat-register-verification-code/", views.RepeatLoginVerificationCode.as_view(), name='login_otp'),
    path('repeat-remember-email-password-code/', views.RepeatRememberEmailPassword.as_view(), name='email_otp'),
    path('forgot-password', views.RememberEmailPasswordView.as_view(), name='forgot_password'),
    path('verify-remember-password', views.RememberVerifyEmailCode.as_view(), name='check_remember_password'),
    path('logout', views.Logout.as_view(), name='logout'),
    path('register/', views.register, name='register'),
    path('profile/', views.Profile.as_view(), name='profile'),
    path('profile/password_change/', views.change_password, name='password_change'),
]

order/urls.py
from django.urls import path
from . import views

app_name = 'order'
urlpatterns = [
    path('order', views.add_order, name='add_order'),
    path('increase', views.increase_count, name='increase_count'),
    path('decrease', views.decrease_count, name='decrease_count'),
    path('checkout', views.check_out, name='checkout'),
]

restaurant/api/urls.py
from django.urls import path
from . import views

app_name = 'api_restaurant'
urlpatterns = [
    path('', views.RestaurantListAPIView.as_view(), name='restaurant_list_api_view'),
    path('<slug:slug>/', views.RestaurantRetrieveAPIView.as_view(), name='restaurant_retrieve_api_view')
]

restaurant/urls.py
from django.urls import path
from . import views

app_name = 'restaurants'
urlpatterns = [
    path('', views.restaurants, name='restaurants'),
    path('<slug:slug>/', views.restaurant, name='restaurant'),
]

snap_food/urls.py
from django.conf.urls.i18n import i18n_patterns
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from rest_framework_jwt.views import obtain_jwt_token

urlpatterns = i18n_patterns(
    path('admin/', admin.site.urls),
    path('', include('account.urls', namespace='account')),
    path('restaurants/', include('restaurant.urls', namespace='restaurants')),
    path('order/', include('order.urls', namespace='order')),
    path('profile/comment/', include('comment.urls', namespace='comment')),
    path('api-token-auth/', obtain_jwt_token),
    path('api/account/', include('account.api.urls', namespace='api_account')),
    path('api/restaurants/', include('restaurant.api.urls', namespace='api_restaurant')),
    path('api/order/', include('order.api.urls', namespace='api_order'))

)
if settings.DEBUG:
    import debug_toolbar
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += path('__debug__/', include(debug_toolbar.urls)),

restaurant/models.py
from django.contrib.contenttypes.models import ContentType
from django.db import models
from django.db.models import Avg, F, Sum
from django.urls import reverse
from django.utils.translation import ugettext_lazy as _

from core.models import BaseModel
from .constants import SERVICE_CHOICES, TIME_TO_DELIVERY_CHOICES
from .managers import RestaurantManager


class Restaurant(BaseModel):
    name = models.CharField(max_length=250, verbose_name=_('name'))
    slug = models.SlugField(unique=True)
    orders_type = models.CharField(max_length=250, verbose_name=_('orders_type'))
    working_times = models.TextField(verbose_name=_('working_times'))
    service_scope = models.TextField(verbose_name=_('service_scope'))
    minimum_order = models.PositiveIntegerField(verbose_name=_('minimum_order'), default=0)
    rate = models.FloatField(verbose_name=_('rate'), null=True)
    time_to_delivery = models.IntegerField(choices=TIME_TO_DELIVERY_CHOICES, verbose_name=_('time_to_delivery'))
    image = models.ImageField(verbose_name=_('image'), upload_to='images/restaurant')
    service_type = models.IntegerField('service type', choices=SERVICE_CHOICES)
    # address fields
    # scope = models.CharField(max_length=250, verbose_name=_('scope'))
    # location = models.CharField(max_length=250, verbose_name=_('location'))
    # tag = models.CharField(max_length=250, verbose_name=_('tag'))
    lat = models.DecimalField(verbose_name=_("latitude"), max_digits=8,
                              decimal_places=4, null=True)
    long = models.DecimalField(verbose_name=_("longitude"), max_digits=8,
                               decimal_places=4, null=True)
    service_area = models.SmallIntegerField(_("service area"), null=True)

    categories = models.ManyToManyField('Category', through='RestaurantCategory', related_name='restaurants')

    objects = RestaurantManager()

    class Meta:
        db_table = 'restaurant'
        verbose_name = _('restaurant')
        verbose_name_plural = _('restaurants')

    def get_absolute_url(self):
        return reverse('restaurants:restaurant', args=[self.slug])

    def __str__(self):
        return self.name

    def get_comments(self):
        return self.comments.all() \
            .annotate(
            average_rate=(Sum(
                F('food_quality') + F('packaging_quality') + F('speed_transfer') + F('agent')) / 4))

    def get_average_rate(self):
        return self.get_comments().aggregate(total_rate=Avg('average_rate'))['total_rate']

    def get_agent_average(self):
        try:
            result = self.get_comments().aggregate(total_rate=Avg('average_rate'))['total_rate'] * 20
        except:
            return None
        return result

    def get_food_quality_average(self):
        try:
            result = self.comments.aggregate(food_quality_average=Avg('food_quality'))['food_quality_average'] * 20
        except:
            return None
        return result

    def get_packaging_quality_average(self):
        try:
            result = self.comments.aggregate(packaging_quality_average=Avg('packaging_quality'))[
                         'packaging_quality_average'] * 20
        except:
            return None
        return result

    def get_speed_transfer_average(self):
        try:
            result = self.comments.aggregate(food_quality_average=Avg('speed_transfer'))['food_quality_average'] * 20
        except:
            return None
        return result


class Category(BaseModel):
    title = models.CharField(max_length=25, verbose_name=_('category'))

    class Meta:
        db_table = 'category'
        verbose_name = _('category')
        verbose_name_plural = _('categories')

    def __str__(self):
        return self.title


class Food(BaseModel):
    title = models.CharField(max_length=250, verbose_name=_('title'))
    price = models.PositiveIntegerField()
    description = models.TextField(verbose_name=_('description'))
    active = models.BooleanField(verbose_name=_('active'), default=True)
    image = models.ImageField(upload_to="images/food/", verbose_name=_('image'))

    restaurant = models.ForeignKey(Restaurant, on_delete=models.CASCADE, related_name='foods',
                                   verbose_name=_('restaurant'))
    category = models.ForeignKey(Category, on_delete=models.CASCADE, verbose_name=_('category'),
                                 related_name='foods')

    class Meta:
        db_table = 'food'
        verbose_name = _('food')
        verbose_name_plural = _('foods')

    def __str__(self):
        return self.title


class RestaurantCategory(BaseModel):
    restaurant = models.ForeignKey(Restaurant, models.CASCADE, related_name='restaurant_categories')
    category = models.ForeignKey(Category, models.CASCADE, related_name='restaurant_categories')

    class Meta:
        db_table = 'restaurant_category'

restaurant/api/views.py
from django_filters.rest_framework import DjangoFilterBackend
from rest_framework import generics
from rest_framework.filters import SearchFilter
from rest_framework.permissions import AllowAny

from restaurant.api.paginations import RestaurantListPagination
from restaurant.api.serializers import RestaurantListSerializer, \
    RestaurantSerializer
from restaurant.models import Restaurant


class RestaurantListAPIView(generics.ListAPIView):
    permission_classes = (AllowAny,)
    serializer_class = RestaurantListSerializer
    pagination_class = RestaurantListPagination
    queryset = Restaurant.objects.prefetch_related('comments').all()
    filter_backends = (SearchFilter, DjangoFilterBackend)
    search_fields = ('name',)
    filterset_fields = ('service_type',)


class RestaurantRetrieveAPIView(generics.RetrieveAPIView):
    permission_classes = (AllowAny,)
    serializer_class = RestaurantSerializer
    queryset = Restaurant.objects.all()

    def get_object(self):
        obj = Restaurant.objects.prefetch_related('comments', 'foods').filter(slug=self.kwargs['slug']).first()
        return obj

restaurant/views.py
from django.shortcuts import render, get_object_or_404

from order.forms import CheckoutForm
from .models import Restaurant, Category


def restaurants(request):
    params = dict(request.GET)
    service_type = request.GET.get('service_type')
    ordering = request.GET.get('ordering')
    filters = params.get('filters')
    food_type = params.get('food_type')
    context = dict()
    context['categories'] = Category.objects.all()
    try:
        context['restaurants'] = Restaurant.objects.get_restaurants(service_type, ordering, filters, food_type)
    except:
        context['restaurants'] = None
    return render(request, 'restaurant/restaurants.html', context)


def restaurant(request, slug):
    context = dict()
    context['restaurant'] = get_object_or_404(Restaurant, slug=slug)
    context['comments'] = context['restaurant'].get_comments()
    context['average_rate'] = context['restaurant'].get_average_rate()
    context['food_quality_average'] = context['restaurant'].get_food_quality_average()
    context['packaging_quality_average'] = context['restaurant'].get_packaging_quality_average()
    context['speed_transfer_average'] = context['restaurant'].get_speed_transfer_average()
    context['agent_average'] = context['restaurant'].get_agent_average()
    context['form'] = CheckoutForm()
    return render(request, 'restaurant/restaurant.html', context)

templates/restaurant/restaurants.html
{% extends 'base.html' %}
{% load static %}
{% load crispy_forms_tags %}
{% load i18n %}
{% block title %}
    {% trans "Restaurants" %}
{% endblock %}

{% block body %}
    <div class="container-fluid mb-3">
        <nav class="navbar navbar-expand-lg navbar-light bg-light fixed-top">
            <a class="navbar-brand" href="#">اسنپ فود</a>
            <button class="navbar-toggler" type="button" data-toggle="collapse"
                    data-target="#navbarNavDropdown"
                    aria-controls="navbarNavDropdown" aria-expanded="false"
                    aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarNavDropdown">
                <ul class="navbar-nav">
                    <li class="nav-item dropdown ml-3">
                        <a class="nav-link dropdown-toggle" href="#"
                           id="navbarDropdownMenuLink" role="button"
                           data-toggle="dropdown" aria-haspopup="true"
                           aria-expanded="false">
                            {{ request.user.name }}
                        </a>
                        <div class="dropdown-menu"
                             aria-labelledby="navbarDropdownMenuLink">
                            <a class="dropdown-item" href="#">فعالیت ها</a>
                            <a class="dropdown-item" href="#">آدرس ها</a>
                            <a class="dropdown-item" href="#">تنظیمات</a>
                            <a class="dropdown-item" href="{% url 'account:logout' %}">خروج</a>
                        </div>
                    </li>
                    <li class="nav-item ml-3">
                        <a class="nav-link" href="#">اعتبار <span>100 تومان</span></a>
                    </li>
                    <li class="nav-item ml-3">
                        <a class="nav-link" href="#">راهنما</a>
                    </li>
                </ul>
            </div>
        </nav>
    </div>
    <div class="container-fluid" id="search">
        <br>
        <br>
        <br>
        <form action="#">
            <div class="form-row justify-content-center">
                <div class="col-md-2 mb-1">
                    <input type="text" class="form-control" placeholder="شهر">
                </div>
                <div class="col-md-2 mb-1">
                    <input type="text" class="form-control" placeholder="محله">
                </div>
                <div class="col-md-2 mb-1">
                    <input type="text" class="form-control" placeholder="غذا">
                </div>
                <div class="col-md-2 mb-1">
                    <input type="text" class="form-control" placeholder="رستوران">
                </div>
                <div class="col-md-2 mb-1">
                    <input type="submit" class="form-control btn-success"
                           placeholder="جستجو" value="جستجو">
                </div>
            </div>

        </form>
        <br>
        <br>
        <br>
        <br>
    </div>
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-3">
                <form action="{% url 'restaurants:restaurants' %}" id="getRestaurant" method="get">
                    <div class="card bg-light mb-3">
                        <div class="card-header">خدمات</div>
                        <div class="card-body yekan">
                            <div class="form-check mb-3">
                                <input class="form-check-input" type="radio"
                                       name="service_type" id="all"
                                       value="all" checked>
                                <label class="form-check-label"
                                       for="all">
                                    همه
                                </label>
                            </div>
                            <div class="form-check mb-3">
                                <input class="form-check-input" type="radio"
                                       name="service_type" id="confectionery"
                                       value="confectionery" checked>
                                <label class="form-check-label"
                                       for="confectionery">
                                    شیرینی
                                </label>
                            </div>
                            <div class="form-check mb-3">
                                <input class="form-check-input" type="radio"
                                       name="service_type" id="restaurant"
                                       value="restaurant" checked>
                                <label class="form-check-label"
                                       for="restaurant">
                                    رستوران
                                </label>
                            </div>
                            <div class="form-check mb-3">
                                <input class="form-check-input" type="radio"
                                       name="service_type" id="cofee"
                                       value="cofee" checked>
                                <label class="form-check-label"
                                       for="cofee">
                                    کافی شاپ
                                </label>
                            </div>
                            <div class="form-check mb-3">
                                <input class="form-check-input" type="radio"
                                       name="service_type" id="super_market"
                                       value="super_market" checked>
                                <label class="form-check-label"
                                       for="super_market">
                                    سوپرمارکت
                                </label>
                            </div>
                        </div>
                    </div>
                    <div class="card bg-light mb-3">
                        <div class="card-header">مرتب کردن بر اساس</div>
                        <div class="card-body yekan">
                            <div class="form-check mb-3">
                                <input class="form-check-input" type="radio"
                                       name="ordering" id="max_rate"
                                       value="max_rate" checked>
                                <label class="form-check-label"
                                       for="max_rate">
                                    بیشترین امتیاز
                                </label>
                            </div>
                            <div class="form-check mb-3">
                                <input class="form-check-input" type="radio"
                                       name="ordering" id="speed"
                                       value="speed" checked>
                                <label class="form-check-label"
                                       for="speed">
                                    سریع ترین زمان ارسال
                                </label>
                            </div>
                            <div class="form-check mb-3">
                                <input class="form-check-input" type="radio"
                                       name="ordering" id="newest"
                                       value="newest" checked>
                                <label class="form-check-label"
                                       for="newest">
                                    جدیدترین ها
                                </label>
                            </div>
                        </div>
                    </div>
                    <div class="card bg-light mb-3">
                        <div class="card-header">فیلترها</div>
                        <div class="card-body yekan">
                            <div class="form-check mb-3">
                                <input class="form-check-input" type="checkbox"
                                       name="filters" id="has_coupon"
                                       value="has_coupon">
                                <label class="form-check-label"
                                       for="has_coupon">
                                    دارای کوپن
                                </label>
                            </div>
                            <div class="form-check mb-3">
                                <input class="form-check-input" type="checkbox"
                                       name="filters" id="has_discount"
                                       value="has_discount">
                                <label class="form-check-label"
                                       for="has_discount">
                                    دارای تخفیف
                                </label>
                            </div>
                        </div>
                    </div>
                    <div class="card bg-light mb-1">
                        <div class="card-header">نوع غذا</div>
                        <div class="card-body yekan">
                            {% for category in categories %}
                                <div class="form-check mb-3">
                                    <input class="form-check-input" type="checkbox"
                                           name="food_type"
                                           id="category{{ category.id }}"
                                           value="{{ category.id }}">
                                    <label class="form-check-label"
                                           for="category{{ category.id }}">
                                        {{ category.title }}
                                    </label>
                                </div>
                            {% endfor %}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12"></div>
                        <input type="submit" class="btn-success col-11 mr-3 ml-3" value="جستجو">
                    </div>

                </form>
            </div>
            <div class="col-md-9">
                {% for restaurant in restaurants %}
                    <div class="card mb-5">
                        <div class="card-body">
                            <div class="row">
                                <div class="col-md-2">
                                    <img src="{{ restaurant.image.url }}"
                                         class="img-thumbnail">
                                </div>
                                <div class="col-md-7">
                                    <h6><a href="{{ restaurant.get_absolute_url }}">{{ restaurant.name }}</a></h6>
                                    <span class="yekan">آدرس:</span>
                                    <span class="yekan">{{ restaurant.scope }}-{{ restaurant.location }}-{{ restaurant.tag }}</span>
                                </div>
                                <div class="col-md-3 ">
                                    <div class="row justify-content-end ml-2">
                                    <span class="yekan mt-2">(
                                {{ restaurant.comments.count }}
                                )
                                نظر</span>
                                        <button type="button"
                                                class="btn btn-outline-success mr-3 yekan">
                                            {{ restaurant.rate }}
                                        </button>
                                        <div><span
                                                class="yekan mt-3">زمان تحویل: {{ restaurant.time_to_delivery }}</span>
                                        </div>
                                        <a href="{% url 'restaurants:restaurant' restaurant.slug %}">
                                        <button type="button"
                                                class="btn btn-outline-danger mr-2 yekan mt-2 btn-block">
                                            نمایش منو
                                        </button>
                                            </a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                {% endfor %}
            </div>
        </div>
    </div>
{% endblock %}